From 7677aea54d6a8cc167ec1040356e27b6ab9366ce Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Jo=CC=88rg=20Bleyel?= <jbleyel@gmx.net>
Date: Fri, 11 Jul 2014 21:35:53 +0200
Subject: [PATCH] speedup message loop main thread delegate call

---
 Sources/VLCEventManager.m | 39 ++++++++++-----------------------------
 1 file changed, 10 insertions(+), 29 deletions(-)

diff --git a/Sources/VLCEventManager.m b/Sources/VLCEventManager.m
index 65d8007..e9384f4 100644
--- a/Sources/VLCEventManager.m
+++ b/Sources/VLCEventManager.m
@@ -79,10 +79,6 @@ typedef enum
 }
 
 - (void)startEventLoop;
-
-- (void)callDelegateOfObjectAndSendNotificationWithArgs:(message_t
-*)message;
-- (void)callObjectMethodWithArgs:(message_t *)message;
 - (void)callDelegateOfObject:(id)aTarget withDelegateMethod:(SEL)aSelector
 withNotificationName:(NSString *)aNotificationName;
 - (pthread_cond_t *)signalData;
@@ -219,14 +215,16 @@ static void * EventDispatcherMainLoop(void * user_data)
 
             pthread_mutex_unlock([self queueLock]);
 
-            if (message.type == VLCNotification)
-                [self performSelectorOnMainThread:@selector(callDelegateOfObjectAndSendNotificationWithArgs:)
-                                       withObject:message
-                                    waitUntilDone: NO];
-            else
-                [self performSelectorOnMainThread:@selector(callObjectMethodWithArgs:)
-                                       withObject:message
-                                    waitUntilDone: YES];
+            dispatch_async(dispatch_get_main_queue(), ^{
+                if ([self markMessageHandledOnMainThreadIfExists:message]) {
+                    if (message.type == VLCNotification) {
+                        [self callDelegateOfObject:message.target withDelegateMethod:message.sel withNotificationName:message.name];
+                    } else {
+                        void (*method)(id, SEL, id) = (void (*)(id, SEL, id))[message.target methodForSelector: message.sel];
+                        method(message.target, message.sel, message.object);
+                    }
+                }
+            });
         }
     }
 }
@@ -310,23 +308,6 @@ static void * EventDispatcherMainLoop(void * user_data)
     return !cancelled;
 }
 
-- (void)callDelegateOfObjectAndSendNotificationWithArgs:(message_t *)message
-{
-    // Check that we were not cancelled, ie, target was released
-    if ([self markMessageHandledOnMainThreadIfExists:message])
-        [self callDelegateOfObject:message.target withDelegateMethod:message.sel withNotificationName:message.name];
-
-}
-
-- (void)callObjectMethodWithArgs:(message_t *)message
-{
-    // Check that we were not cancelled
-    if ([self markMessageHandledOnMainThreadIfExists:message]) {
-        void (*method)(id, SEL, id) = (void (*)(id, SEL, id))[message.target methodForSelector: message.sel];
-        method(message.target, message.sel, message.object);
-    }
-}
-
 - (void)callDelegateOfObject:(id)aTarget withDelegateMethod:(SEL)aSelector withNotificationName:(NSString *)aNotificationName
 {
     [[NSNotificationCenter defaultCenter] postNotification: [NSNotification notificationWithName:aNotificationName object:aTarget]];
-- 
1.8.5.2 (Apple Git-48)

